Index: issm/trunk/src/m/classes/solidearth.js
===================================================================
--- issm/trunk/src/m/classes/solidearth.js	(revision 26744)
+++ issm/trunk/src/m/classes/solidearth.js	(revision 26744)
@@ -0,0 +1,135 @@
+class solidearth {//{{{
+	/**
+	 * SOLIDEARTH class definition
+	 *
+	 * Usage:
+	 *     solidearth = solidearth();
+	 *     solidearth = solidearth('earth');
+	 */
+	constructor() {//{{{
+		this.settings = new solidearthsettings();
+		this.external = null;
+		this.lovenumbers = new lovenumbers();
+		this.rotational = new rotational();
+		this.planetradius = planetradius('earth');
+		this.requested_outputs = [];
+		this.transitions = [];
+		this.partitionice = [];
+		this.partitionhydro = [];
+		this.partitionocean = [];
+
+		let nargs = arguments.length;
+		if (nargs == 0) {
+			this.setdefaultparameters('earth');
+		} else if (nargs == 1) {
+			this.setdefaultparameters(arguments[0]);
+		} else {
+			error('solidearth constructor error message: zero or one argument only!');
+		}
+	} //}}}
+
+	disp() {//{{{
+		console.log('WARNING: solidearth::disp is not yet implemented');
+	} //}}}
+
+	setdefaultparameters(planet) {//{{{
+		// Output default
+		this.requested_outputs = ['default'];
+
+		// Transitions should be an array
+		this.transitions = [];
+
+		// No partitions requested for barystatic contribution
+		this.partitionice = [];
+		this.partitionhydro = [];
+		this.partitionocean = [];
+
+		// No external solutions by default
+		this.external = null;
+
+		// Planet radius
+		this.planetradius = planetradius(planet);
+	} //}}}
+
+	checkconsistency(md, solution, analyses) {//{{{
+		if (!analyses.includes('SealevelchangeAnalysis') || (solution === 'TransientSolution' && !md.transient.isslc)) {
+			return md;
+		}
+
+		md = checkfield(md, 'fieldname', 'solidearth.requested_outputs', 'stringrow', 1);
+
+		this.settings.checkconsistency(md, solution, analyses);
+		this.lovenumbers.checkconsistency(md, solution, analyses);
+		this.rotational.checkconsistency(md, solution, analyses);
+
+		if (this.external != null) {
+			if (typeof(this.external) != 'solidearthsolution') {
+				error('solidearth consistency check: external field should be a solidearthsolution');
+			}
+		}
+
+		return md;
+	} //}}}
+
+	defaultoutputs(md) {//{{{
+		return ['Sealevel'];
+	} //}}}
+
+	marshall(md, prefix, fid) {//{{{
+		WriteData(fid, prefix, 'object', this, 'fieldname', 'planetradius', 'format', 'Double');
+		WriteData(fid, prefix, 'object', this, 'fieldname', 'transitions', 'format', 'MatArray');
+
+		let npartice = 0;
+		if (this.partitionice.length) {
+			npartice = max(this.partitionice) + 2;
+		}
+
+		let nparthydro = 0;
+		if (this.partitionhydro.length) {
+			nparthydro = max(this.partitionhydro) + 2;
+		}
+
+		let npartocean = 0;
+		if (this.partitionocean.length) {
+			npartocean = max(this.partitionocean) + 2;
+		}
+
+		WriteData(fid, prefix, 'object', this, 'fieldname', 'partitionice', 'mattype', 1, 'format', 'DoubleMat');
+		WriteData(fid, prefix, 'data', npartice, 'format', 'Integer', 'name', 'md.solidearth.npartice');
+		WriteData(fid, prefix, 'object', this, 'fieldname', 'partitionhydro', 'mattype', 1, 'format', 'DoubleMat');
+		WriteData(fid, prefix, 'data', nparthydro, 'format', 'Integer', 'name', 'md.solidearth.nparthydro');
+		WriteData(fid, prefix, 'object', this, 'fieldname', 'partitionocean', 'mattype', 1, 'format', 'DoubleMat');
+		WriteData(fid, prefix, 'data', npartocean, 'format', 'Integer', 'name', 'md.solidearth.npartocean');
+
+		this.settings.marshall(md, prefix, fid);
+		this.lovenumbers.marshall(md, prefix, fid);
+		this.rotational.marshall(md, prefix, fid);
+
+		if (this.external != null) {
+			WriteData(fid, prefix, 'data', 1, 'format', 'Integer', 'name', 'md.solidearth.isexternal');
+			this.external.marshall(md, prefix, fid);
+		} else {
+			WriteData(fid, prefix, 'data', 0, 'format', 'Integer', 'name', 'md.solidearth.isexternal');
+		}
+
+		// Process requested outputs
+		let outputs = this.requested_outputs;
+		let pos = find(ismember(outputs, 'default'));
+		if (pos.length) {
+			/*
+			NOTE: In order to handle case where user has added 'default' more 
+			than once to this.requested_outputs, need to remove elements by 
+			index in reverse order.
+			*/
+			for (let i = (pos.length - 1); i >= 0; --i) {
+				outputs.splice(pos[i], 1);
+			}
+
+			outputs.push(this.defaultoutputs(md));
+		}
+		WriteData(fid, prefix, 'data', outputs, 'name', 'md.solidearth.requested_outputs', 'format', 'StringArray');
+	} //}}}
+
+	extrude(md) {//{{{
+	} //}}}
+} //}}}
Index: issm/trunk/src/m/classes/solidearth.m
===================================================================
--- issm/trunk/src/m/classes/solidearth.m	(revision 25994)
+++ issm/trunk/src/m/classes/solidearth.m	(revision 26744)
@@ -3,11 +3,10 @@
 %   Usage:
 %      solidearth=solidearth();
+%      solidearth=solidearth('earth');
 
 classdef solidearth
 	properties (SetAccess=public) 
-		initialsealevel        = NaN;
 		settings               = solidearthsettings(); 
 		external               = [];
-		surfaceload            = surfaceload();
 		lovenumbers            = lovenumbers();
 		rotational             = rotational();
@@ -17,4 +16,22 @@
 		partitionice           = [];
 		partitionhydro         = [];
+		partitionocean         = [];
+	end
+	methods (Static)
+		function self = loadobj(self) % {{{
+			% This function is directly called by matlab when a model object is
+			% loaded. If the input is a struct it is an old version of this class and
+			% old fields must be recovered (make sure they are in the deprecated
+			% model properties)
+
+			if isstruct(self)
+				% 2021, Jan 10
+				if isfield(self,'sealevel')
+					self.initialsealevel = self.sealevel;
+				end
+				self = structtoobj(solidearth(),self);
+
+			end
+		end% }}}
 	end
 	methods
@@ -29,4 +46,22 @@
 			end
 		end % }}}
+		function disp(self) % {{{
+			disp(sprintf('   solidearth inputs, forcings and settings:'));
+
+			fielddisplay(self,'planetradius','planet radius [m]');
+			fielddisplay(self,'transitions','indices into parts of the mesh that will be icecaps');
+			fielddisplay(self,'requested_outputs','additional outputs requested');
+			fielddisplay(self,'partitionice','ice partition vector for barystatic contribution');
+			fielddisplay(self,'partitionhydro','hydro partition vector for barystatic contribution');
+			fielddisplay(self,'partitionocean','ocean partition vector for barystatic contribution');
+			if isempty(self.external), fielddisplay(self,'external','external solution, of the type solidearthsolution'); end
+			self.settings.disp();
+			self.lovenumbers.disp();
+			self.rotational.disp();
+			if ~isempty(self.external),
+				self.external.disp();
+			end
+
+		end % }}}
 		function self = setdefaultparameters(self,planet) % {{{
 
@@ -34,29 +69,28 @@
 			self.requested_outputs={'default'};
 
-			%transitions should be a cell array of vectors: 
+			%transitions should be a cell array of vectors:
 			self.transitions={};
-			
-			%no partitions requested for barystatic contribution: 
+
+			%no partitions requested for barystatic contribution:
 			self.partitionice=[];
 			self.partitionhydro=[];
+			self.partitionocean=[];
 
-			%no external solutions by defalt: 
+			%no external solutions by default:
 			self.external=[];
 
-			%earth radius
+			%planet radius
 			self.planetradius= planetradius(planet);
-		
+
 		end % }}}
 		function md = checkconsistency(self,md,solution,analyses) % {{{
 
-			if ~ismember('SealevelriseAnalysis',analyses) | (strcmp(solution,'TransientSolution') & md.transient.isslr==0), 
+			if ~ismember('SealevelchangeAnalysis',analyses) | (strcmp(solution,'TransientSolution') & md.transient.isslc==0), 
 				return; 
 			end
 
-			md = checkfield(md,'fieldname','solidearth.initialsealevel','NaN',1,'Inf',1,'size',[md.mesh.numberofvertices 1]);
 			md = checkfield(md,'fieldname','solidearth.requested_outputs','stringrow',1);
 
 			self.settings.checkconsistency(md,solution,analyses);
-			self.surfaceload.checkconsistency(md,solution,analyses);
 			self.lovenumbers.checkconsistency(md,solution,analyses);
 			self.rotational.checkconsistency(md,solution,analyses);
@@ -68,34 +102,13 @@
 			end
 
-			
 		end % }}}
 		function list=defaultoutputs(self,md) % {{{
 			list = {'Sealevel'};
 		end % }}}
-		function disp(self) % {{{
-			disp(sprintf('   solidearth inputs, forcings and settings:'));
+		function marshall(self,prefix,md,fid) % {{{
 
-			fielddisplay(self,'initialsealevel','sea level at the start of computation) [m]');
-			fielddisplay(self,'planetradius','planet radius [m]');
-			fielddisplay(self,'transitions','indices into parts of the mesh that will be icecaps');
-			fielddisplay(self,'requested_outputs','additional outputs requested');
-			fielddisplay(self,'partitionice','ice partition vector for barystatic contribution');
-			fielddisplay(self,'partitionhydro','hydro partition vector for barystatic contribution');
-			if isempty(self.external), fielddisplay(self,'external','external solution, of the type solidearthsolution'); end
-			self.settings.disp();
-			self.surfaceload.disp();
-			self.lovenumbers.disp();
-			self.rotational.disp();
-			if ~isempty(self.external),
-				self.external.disp();
-			end
-
-		end % }}}
-		function marshall(self,prefix,md,fid) % {{{
-			
-			WriteData(fid,prefix,'object',self,'fieldname','initialsealevel','mattype',1,'format','DoubleMat','timeserieslength',md.mesh.numberofvertices+1,'yts',md.constants.yts);
 			WriteData(fid,prefix,'object',self,'fieldname','planetradius','format','Double');
 			WriteData(fid,prefix,'object',self,'fieldname','transitions','format','MatArray');
-		
+
 			if ~isempty(self.partitionice),
 				npartice=max(self.partitionice)+2;
@@ -103,4 +116,5 @@
 				npartice=0;
 			end
+
 			if ~isempty(self.partitionhydro),
 				nparthydro=max(self.partitionhydro)+2;
@@ -108,22 +122,30 @@
 				nparthydro=0;
 			end
+			if ~isempty(self.partitionocean),
+				npartocean=max(self.partitionocean)+2;
+			else
+				npartocean=0;
+			end
 
-			
 			WriteData(fid,prefix,'object',self,'fieldname','partitionice','mattype',1,'format','DoubleMat');
 			WriteData(fid,prefix,'data',npartice,'format','Integer','name','md.solidearth.npartice');
 			WriteData(fid,prefix,'object',self,'fieldname','partitionhydro','mattype',1,'format','DoubleMat');
 			WriteData(fid,prefix,'data',nparthydro,'format','Integer','name','md.solidearth.nparthydro');
-			
+			WriteData(fid,prefix,'object',self,'fieldname','partitionocean','mattype',1,'format','DoubleMat');
+			WriteData(fid,prefix,'data',npartocean,'format','Integer','name','md.solidearth.npartocean');
+
 			self.settings.marshall(prefix,md,fid);
-			self.surfaceload.marshall(prefix,md,fid);
 			self.lovenumbers.marshall(prefix,md,fid);
 			self.rotational.marshall(prefix,md,fid);
 			if ~isempty(self.external),
+				WriteData(fid,prefix,'data',1,'format','Integer','name','md.solidearth.isexternal');
 				self.external.marshall(prefix,md,fid);
+			else
+				WriteData(fid,prefix,'data',0,'format','Integer','name','md.solidearth.isexternal');
 			end
-			
+
 			%process requested outputs
 			outputs = self.requested_outputs;
-			pos  = find(ismember(outputs,'default'));
+			pos = find(ismember(outputs,'default'));
 			if ~isempty(pos),
 				outputs(pos) = [];                         %remove 'default' from outputs
@@ -133,9 +155,9 @@
 
 		end % }}}
+		function self = extrude(self,md) % {{{
+		end % }}}
 		function savemodeljs(self,fid,modelname) % {{{
 		
-			writejs1Darray(fid,[modelname '.solidearth.initialsealevel'],self.initialsealevel);
 			self.settings.savemodeljs(fid,modelname);
-			self.surfaceload.savemodeljs(fid,modelname);
 			self.lovenumbers.savemodeljs(fid,modelname);
 			self.rotational.savemodeljs(fid,modelname);
@@ -147,7 +169,4 @@
 			writejscellarray(fid,[modelname '.solidearth.partition'],self.partition);
 		end % }}}
-		function self = extrude(self,md) % {{{
-			self.initialsealevel=project3d(md,'vector',self.initialsealevel,'type','node');
-		end % }}}
 	end
 end
Index: issm/trunk/src/m/classes/solidearth.py
===================================================================
--- issm/trunk/src/m/classes/solidearth.py	(revision 25994)
+++ issm/trunk/src/m/classes/solidearth.py	(revision 26744)
@@ -4,9 +4,10 @@
 from fielddisplay import fielddisplay
 from lovenumbers import lovenumbers
+from MatlabFuncs import *
 from planetradius import planetradius
 from project3d import project3d
 from rotational import rotational
 from solidearthsettings import solidearthsettings
-from surfaceload import surfaceload
+from solidearthsolution import solidearthsolution
 from WriteData import WriteData
 
@@ -17,11 +18,13 @@
     Usage:
         solidearth = solidearth()
+        solidearth = solidearth('earth')
+
+    TODO:
+    - Update translation from solidearth.m
     """
 
-    def __init__(self, *args):  #{{{
-        self.initialsealevel    = np.nan
+    def __init__(self, *args):  # {{{
         self.settings           = solidearthsettings()
-        self.external           = []
-        self.surfaceload        = surfaceload()
+        self.external           = None
         self.lovenumbers        = lovenumbers()
         self.rotational         = rotational()
@@ -31,7 +34,7 @@
         self.partitionice       = []
         self.partitionhydro     = []
+        self.partitionocean     = []
 
         nargs = len(args)
-
         if nargs == 0:
             self.setdefaultparameters('earth')
@@ -40,9 +43,7 @@
         else:
             raise Exception('solidearth constructor error message: zero or one argument only!')
-    #}}}
-
+    # }}}
     def __repr__(self):  # {{{
         s = '   solidearthinputs, forcings and settings:\n'
-        s += '{}\n'.format(fielddisplay(self, 'initialsealevel', 'sea level at the start of computation [m]'))
         s += '{}\n'.format(fielddisplay(self, 'planetradius', 'planet radius [m]'))
         s += '{}\n'.format(fielddisplay(self, 'transitions', 'indices into parts of the mesh that will be icecaps'))
@@ -50,17 +51,16 @@
         s += '{}\n'.format(fielddisplay(self, 'partitionice', 'ice partition vector for barystatic contribution'))
         s += '{}\n'.format(fielddisplay(self, 'partitionhydro', 'hydro partition vector for barystatic contribution'))
+        s += '{}\n'.format(fielddisplay(self, 'partitionocean', 'ocean partition vector for barystatic contribution'))
         if not self.external:
             s += '{}\n'.format(fielddisplay(self, 'external', 'external solution, of the type solidearthsolution'))
         print(self.settings)
-        print(self.surfaceload)
         print(self.lovenumbers)
         print(self.rotational)
-        if self.external:
+        if len(self.external):
             print(self.external)
         return s
-    #}}}
-
+    # }}}
     def setdefaultparameters(self, planet):  # {{{
-        # Default output
+        # Output default
         self.requested_outputs = ['default']
 
@@ -71,36 +71,31 @@
         self.partitionice = []
         self.partitionhydro = []
+        self.partitionocean = []
 
-        # No external solutions by defalt
-        self.external = []
+        # No external solutions by default
+        self.external = None
 
-        # Earth radius
+        # Planet radius
         self.planetradius = planetradius(planet)
-    #}}}
+    # }}}
+    def checkconsistency(self, md, solution, analyses):  # {{{
+        if ('SealevelchangeAnalysis' not in analyses) or (solution == 'TransientSolution' and not md.transient.isslc):
+            return md
 
-    def checkconsistency(self, md, solution, analyses):  # {{{
-        if ('SealevelriseAnalysis' not in analyses) or (solution == 'TransientSolution' and not md.transient.isslr):
-            return md
-        md = checkfield(md, 'fieldname', 'solidearth.initialsealevel', 'NaN', 1, 'Inf', 1, 'size', [md.mesh.numberofvertices])
         md = checkfield(md, 'fieldname', 'solidearth.requested_outputs', 'stringrow', 1)
 
         self.settings.checkconsistency(md, solution, analyses)
-        self.surfaceload.checkconsistency(md, solution, analyses)
         self.lovenumbers.checkconsistency(md, solution, analyses)
         self.rotational.checkconsistency(md, solution, analyses)
         if self.external:
-            if not isinstance(self.external,'solidearthsolution'):
+            if not isa(self.external, solidearthsolution):
                 raise Exception('solidearth consistency check: external field should be a solidearthsolution')
-            end
-            self.external.checkconsistency(md,solution,analyses)
+            self.external.checkconsistency(md, solution, analyses)
         return md
-    #}}}
-
-    def defaultoutputs(self, md):  #{{{
+    # }}}
+    def defaultoutputs(self, md):  # {{{
         return ['Sealevel']
-    #}}}
-
-    def marshall(self, prefix, md, fid):  #{{{
-        WriteData(fid, prefix, 'object', self, 'fieldname', 'initialsealevel', 'mattype', 1, 'format', 'DoubleMat', 'timeserieslength', md.mesh.numberofvertices + 1, 'yts', md.constants.yts)
+    # }}}
+    def marshall(self, prefix, md, fid):  # {{{
         WriteData(fid, prefix, 'object', self, 'fieldname', 'planetradius', 'format', 'Double')
         WriteData(fid, prefix, 'object', self, 'fieldname', 'transitions', 'format', 'MatArray')
@@ -116,27 +111,34 @@
             nparthydro = 0
 
+        if len(self.partitionocean):
+            npartocean = np.max(self.partitionocean) + 2
+        else:
+            npartocean = 0
+
         WriteData(fid, prefix, 'object', self, 'fieldname', 'partitionice', 'mattype', 1, 'format', 'DoubleMat');
         WriteData(fid, prefix, 'data', npartice, 'format', 'Integer', 'name', 'md.solidearth.npartice');
         WriteData(fid, prefix, 'object', self, 'fieldname', 'partitionhydro', 'mattype', 1, 'format', 'DoubleMat');
         WriteData(fid, prefix, 'data', nparthydro,'format', 'Integer', 'name','md.solidearth.nparthydro');
+        WriteData(fid, prefix, 'object', self, 'fieldname', 'partitionocean', 'mattype', 1, 'format', 'DoubleMat');
+        WriteData(fid, prefix, 'data', npartocean,'format', 'Integer', 'name','md.solidearth.npartocean');
 
         self.settings.marshall(prefix, md, fid)
-        self.surfaceload.marshall(prefix, md, fid)
         self.lovenumbers.marshall(prefix, md, fid)
         self.rotational.marshall(prefix, md, fid)
         if self.external:
+            WriteData(fid, prefix, 'data', 1, 'format', 'Integer', 'name', 'md.solidearth.isexternal')
             self.external.marshall(prefix, md, fid)
+        else:
+            WriteData(fid, prefix, 'data', 0, 'format', 'Integer', 'name', 'md.solidearth.isexternal')
 
-        #process requested outputs
+        # Process requested outputs
         outputs = self.requested_outputs
         pos = np.where(np.asarray(outputs) == 'default')[0]
         if len(pos):
-            outputs = np.delete(outputs, pos)  #remove 'default' from outputs
-            outputs = np.append(outputs, self.defaultoutputs(md))  #add defaults
+            outputs = np.delete(outputs, pos) # remove 'default' from outputs
+            outputs = np.append(outputs, self.defaultoutputs(md)) # add defaults
         WriteData(fid, prefix, 'data', outputs, 'name', 'md.solidearth.requested_outputs', 'format', 'StringArray')
-    #}}}
-
-    def extrude(self, md): #{{{
-        self.initialsealevel = project3d(md, 'vector', self.initialsealevel, 'type', 'node')
+    # }}}
+    def extrude(self, md):  # {{{
         return self
-    #}}}
+    # }}}
Index: issm/trunk/src/m/classes/solidearthsettings.js
===================================================================
--- issm/trunk/src/m/classes/solidearthsettings.js	(revision 26744)
+++ issm/trunk/src/m/classes/solidearthsettings.js	(revision 26744)
@@ -0,0 +1,145 @@
+class solidearthsettings {//{{{
+	/**
+	 * SOLIDEARTHSETTINGS class definition
+	 *
+	 * Usage:
+	 *     solidearthsettings = solidearthsettings();
+	 */
+	constructor() {//{{{
+		this.reltol					= 0;
+		this.abstol					= 0;
+		this.maxiter				= 0;
+		this.selfattraction			= 1;
+		this.elastic				= 1;
+		this.viscous				= 1;
+		this.rotation				= 1;
+		this.grdocean				= 1;
+		this.ocean_area_scaling		= 0;
+		this.runfrequency			= 1; // How many time steps will we skip before we run grd_core
+		this.sealevelloading		= 1; // Will sea-level loads be computed?
+		this.isgrd					= 0; // Will GRD patterns be computed?
+		this.compute_bp_grd			= 0; // Will GRD patterns for bottom pressures be computed?
+		this.degacc					= 0; // Degree increment for resolution of Green tables
+		this.timeacc				= 0; // Time step accuracy required to compute Green tables
+		this.horiz					= 0; // Compute horizontal deformation
+		this.grdmodel				= 0; // GRD model (0 by defualt, 1 for (visco-)elastic, 2 for Ivins)
+		this.cross_section_shape	= 0; // Cross section only used when GRD model is Ivins
+
+		if (arguments.length == 0) {
+			this.setdefaultparameters();
+		} else {
+			error('constructor not supported');
+		}
+	} //}}}
+
+	disp() {//{{{
+		console.log('WARNING: solidearthsettings::disp is not yet implemented');
+	} //}}}
+
+	setdefaultparameters() {//{{{
+		// Convergence criterion: absolute, relative, and residual
+		this.restol = 0.01; // 1 percent
+		this.abstol = NaN;
+
+		// Maximum of non-linear iterations
+		this.maxiter = 5;
+
+		// Computational flags
+		this.selfattraction = 1;
+		this.elastic = 1;
+		this.viscous = 1;
+		this.rotation = 1;
+		this.grdocean = 1;
+		this.ocean_area_scaling = 0;
+		this.compute_bp_grd = 0;
+		this.isgrd = 0;
+		this.sealevelloading = 1;
+
+		// Numerical discretiztion accuracy
+		this.degacc = 0.01;
+		this.timeacc = 1;
+
+		// How many time steps we skip before we run solidearthsettings solver during transient
+		this.runfrequency = 1;
+
+		// Horizontal displacement? (not on by default)
+		this.horiz = 0;
+
+		// Cross section for Ivins model
+		this.cross_section_shape = 1; // Square as default (see idege in GiaDeflectionCorex)
+
+		// No GRD model by default
+		this.grdmodel = 0;
+	} //}}}
+
+	checkconsistency(md, solution, analyses) {//{{{
+		if (!analyses.includes('SealevelchangeAnalysis') || (solution === 'TransientSolution' && !md.transient.isslc)) {
+			return md;
+		}
+
+		md = checkfield(md, 'fieldname', 'solidearth.settings.reltol', 'size', [1]);
+		md = checkfield(md, 'fieldname', 'solidearth.settings.abstol', 'size', [1]);
+		md = checkfield(md, 'fieldname', 'solidearth.settings.maxiter', 'size', [1], '>=', 1);
+		md = checkfield(md, 'fieldname', 'solidearth.settings.runfrequency', 'size', [1], '>=', 1);
+		md = checkfield(md, 'fieldname', 'solidearth.settings.degacc', 'size', [1], '>=', 1e-10);
+		md = checkfield(md, 'fieldname', 'solidearth.settings.timeacc', 'size', [1], '>', 0);
+		md = checkfield(md, 'fieldname', 'solidearth.settings.horiz', 'NaN', 1, 'Inf', 1, 'values', [0, 1]);
+		md = checkfield(md, 'fieldname', 'solidearth.settings.grdmodel', '>=', 0, '<=', 2);
+		md = checkfield(md, 'fieldname', 'solidearth.settings.cross_section_shape', 'numel', [1], 'values', [1, 2]);
+
+		// Checks on computational flags
+		if (this.elastic && !this.rigid) {
+			error('solidearthsettings checkconsistency error message: need rigid on if elastic flag is set');
+		}
+		if (this.viscous && !this.elastic) {
+			error('solidearthsettings checkconsistency error message: need elastic on if viscous flag is set');
+		}
+
+		// A GRD computation has been requested, make some checks on the nature of the meshes provided
+		if (this.isgrd) {
+			if (strcmpi(typeof(md.mesh), 'mesh3dsurface')) {
+				if (this.grdmodel == 2) {
+					error('model requires a 2D mesh to run gia Ivins computations (change mesh from mesh3dsurface to mesh2d)');
+				}
+			} else {
+				if (this.grdmodel == 1) {
+					error('model requires a 3D surface mesh to run GRD computations (change mesh from mesh2d to mesh3dsurface)');
+				}
+			}
+			
+			if (this.sealevelloading && !this.grdocean) {
+				error('solidearthsettings checkconsistency error message: need grdocean on if sealevelloading flag is set');
+			}
+		}
+
+		if (this.compute_bp_grd && !md.solidearth.settings.isgrd) {
+			error('solidearthsettings checkconsistency error message; if bottom pressure grd patterns are requested, solidearth settings class should have isgrd flag on');
+		}
+
+		return md;
+	} //}}}
+
+	marshall(md, prefix, fid) {//{{{
+		WriteData(fid, prefix, 'object', this, 'fieldname', 'reltol', 'name', 'md.solidearth.settings.reltol', 'format', 'Double');
+		WriteData(fid, prefix, 'object', this, 'fieldname', 'abstol', 'name', 'md.solidearth.settings.abstol', 'format', 'Double');
+		WriteData(fid, prefix, 'object', this, 'fieldname', 'maxiter', 'name', 'md.solidearth.settings.maxiter', 'format', 'Integer');
+		WriteData(fid, prefix, 'object', this, 'fieldname', 'selfattraction', 'name', 'md.solidearth.settings.selfattraction', 'format', 'Boolean');
+		WriteData(fid, prefix, 'object', this, 'fieldname', 'elastic', 'name', 'md.solidearth.settings.elastic', 'format', 'Boolean');
+		WriteData(fid, prefix, 'object', this, 'fieldname', 'viscous', 'name', 'md.solidearth.settings.viscous', 'format', 'Boolean');
+		WriteData(fid, prefix, 'object', this, 'fieldname', 'rotation', 'name', 'md.solidearth.settings.rotation', 'format', 'Boolean');
+		WriteData(fid, prefix, 'object', this, 'fieldname', 'grdocean', 'name', 'md.solidearth.settings.grdocean', 'format', 'Boolean');
+		WriteData(fid, prefix, 'object', this, 'fieldname', 'ocean_area_scaling', 'name', 'md.solidearth.settings.ocean_area_scaling', 'format', 'Boolean');
+		WriteData(fid, prefix, 'object', this, 'fieldname', 'runfrequency', 'name', 'md.solidearth.settings.runfrequency', 'format', 'Integer');
+		WriteData(fid, prefix, 'object', this, 'fieldname', 'degacc', 'name', 'md.solidearth.settings.degacc', 'format', 'Double');
+		WriteData(fid, prefix, 'object', this, 'fieldname', 'timeacc', 'name', 'md.solidearth.settings.timeacc', 'format', 'Double', 'scale', md.constants.yts);
+		WriteData(fid, prefix, 'object', this, 'fieldname', 'horiz', 'name', 'md.solidearth.settings.horiz', 'format', 'Integer');
+		WriteData(fid, prefix, 'object', this, 'fieldname', 'sealevelloading', 'name', 'md.solidearth.settings.sealevelloading', 'format', 'Integer');
+		WriteData(fid, prefix, 'object', this, 'fieldname', 'isgrd', 'name', 'md.solidearth.settings.isgrd', 'format', 'Integer');
+		WriteData(fid, prefix, 'object', this, 'fieldname', 'compute_bp_grd', 'name', 'md.solidearth.settings.compute_bp_grd', 'format', 'Integer');
+		WriteData(fid, prefix, 'object', this, 'fieldname', 'grdmodel', 'name', 'md.solidearth.settings.grdmodel', 'format', 'Integer');
+		WriteData(fid, prefix, 'object', this, 'fieldname', 'cross_section_shape', 'name', 'md.solidearth.settings.cross_section_shape', 'format', 'Integer');
+	} //}}}
+
+	extrude(md) {//{{{
+	} //}}}
+} //}}}
